/*
 * TopeQueue.h
 *
 *  Created on: Jun 6, 2012
 *      Author: nicolaq
 */

#ifndef TOPEQUEUE_H_
#define TOPEQUEUE_H_

#include"KeyTope.h"

class TopeQueue {
public:
	TopeQueue();
	virtual ~TopeQueue();


	void push(const KeyTope& pTope);
	KeyTope pop();
	bool empty() const;
	unsigned size() const;
	//__uint128_t truncate();

protected:
	void maxHeap(uint64_t index);

	uint64_t mSize;
	bool mReduced;
	vector<KeyTope> mQueue;
};

#endif /* TOPEQUEUE_H_ */
