/*
 * ProcessedEnumeration.h
 *
 *  Created on: Mar 28, 2012
 *      Author: nicolaq
 */

#ifndef PROCESSEDENUMERATION_H_
#define PROCESSEDENUMERATION_H_

#include"Includes.h"
#include"Enumeration.h"
#include<map>

class ProcessedEnumeration {
public:
	ProcessedEnumeration(
			const array<vector<double> , 0x10>& pDistribution);
	~ProcessedEnumeration();

	pair<double, array<unsigned char, 0x10>> nextCandidate();
	uint64_t memSize() const;
protected:
	array<vector<double> , 0x10> process(const array<
			vector<double>, 0x10>& pDistribution);
	pair<double, array<unsigned char, 0x10>> process(const pair<double, array<unsigned char, 0x10>>& pCandidate);

	Enumeration<0x10> mEnumeration;
	array<uint64_t, 0x10> mShuffle;
};

#endif /* PROCESSEDENUMERATION_H_ */
