/*
 * SplitDistribution.h
 *
 *  Created on: Apr 16, 2012
 *      Author: nicolaq
 */

#ifndef SPLITDISTRIBUTION_H_
#define SPLITDISTRIBUTION_H_

#include "Includes.h"
#include"Enumeration.h"

pair<double, uint64_t> splitEntropy(const DistributionType& pDistribution);

pair<double, DistributionType> split(const DistributionType& pDistribution,
		bool pLeft);

multimap<double, DistributionType> splitDistribution(
		const DistributionType& pDistribution, uint64_t numSplit);

array<vector<pair<unsigned char, double>>, 0x10> indexDistribution(const array<vector<double> , 0x10>& pDistribution);

#endif /* SPLITDISTRIBUTION_H_ */
